//
#ifndef	__GL_QUERY__
#define	__GL_QUERY__
#include	"libExt.h"

class Query
{
	GLuint	id;
	GLenum	target;
	
public:
	Query ();
	~Query ();

	void beginQuery ( GLenum theTarget )
	{
		target = theTarget;
		glBeginQuery ( target, id );
	}

	void endQuery ()
	{
		glEndQuery ( target );
	}

	void beginQueryIndexed ( GLenum theTarget, int index )
	{
		target = theTarget;
		glBeginQuery ( target, id );
	}

	void endQueryIndexed ( int index )
	{
		glEndQueryIndexed ( target, index );
	}

	void	timestamp ()
	{
		target = GL_TIMESTAMP;

		glQueryCounter ( target, id );
	}

	bool	 isReady     () const;		// result is ready ?
	GLuint	 getResult   () const;
	GLuint64 getResult64 () const;

	static GLuint	activeQuery ( GLenum theTarget );
	static int	counterBits ( GLenum theTarget );
};

#endif
